#include "DxLib.h"
#include "cSystem.h"

tto::cSystem::cSystem()
{
	iScrollVertical = 0;
	iSelect = 0;
	
	gMenu1 = LoadGraph("data/image/system/menu1.png");
	gMenu2 = LoadGraph("data/image/system/menu2.png");
	gMenu3 = LoadGraph("data/image/system/menu3.png");

	gButton32x32 = LoadGraph("data/image/system/button32x32.png");
	gButton64x32 = LoadGraph("data/image/system/button64x32.png");
	// t@Cw肵At@CI[viG[o狭Ij
	pCopy = fopen("data/save/building.ini", "rb");				if(!pCopy)	{ exit(1); }
	pPaste = fopen("data/admin/building/building.ini", "wb");	if(!pPaste)	{ exit(1); }
	while(!feof(pCopy)){
		ch = fgetc(pCopy);
		if(ferror(pCopy)){ exit(1); }
		if(!feof(pCopy)){ fputc(ch, pPaste); }
		if(ferror(pPaste)){ exit(1); }
	}
	// t@CN[Y
	if (fclose(pCopy) == EOF) { exit(1); }
	if (fclose(pPaste) == EOF) { exit(1); }

	// t@Cw肵At@CI[viG[o狭Ij
	pFile = fopen("data/admin/building/building.ini","rb");		if(!pFile)	{ exit(1); }
	//ǂݍ
	if ( EOF == fread(iBuildingBuffer, sizeof(int), 600, pFile) ) { exit(1); }
	// t@CN[Y
	if (fclose(pFile) == EOF) { exit(1); }
}

void tto::cSystem::fBuilding()
{
	for(i=0; i<100; i++){
		iSetP	= iBuildingBuffer[0+i*6];
		iSetT	= iBuildingBuffer[1+i*6];
		iSetX	= iBuildingBuffer[2+i*6]*32;
		iSetY	= iBuildingBuffer[3+i*6]*32;
		iSetH	= iBuildingBuffer[4+i*6]*32;
		iSetV	= iBuildingBuffer[5+i*6]*32;
		iMX		= iMouseX-iMapMX*32;
		iMY		= iMouseY-iMapMY*32;
		if (fRange(iMX, iSetX, iSetH, iMY, iSetY, iSetV) == 1) {
			if (iSetP == iMyPN) {
				if (iSetT == 0) {
					iSystemFlag = 1;
				}
			}
		}
	}
}

int tto::cSystem::fRange(const int &ixOb, const int &ixMin, const int &ixMax ,
						 const int &iyOb, const int &iyMin, const int &iyMax)
{
	if ( (ixOb > ixMin) && (ixOb < ixMin+ixMax) && 
		 (iyOb > iyMin) && (iyOb < iyMin+iyMax) ) return 1;
	return 0;
}

void tto::cSystem::fSystemInput()
{
	if(iSystemFlag == 1){
		DrawGraph(32,32, gMenu1,TRUE);
	}
	if(iSystemFlag == 2){
		DrawGraph(32,32, gMenu2,TRUE);
	}
	if(iSystemFlag == 3){
		DrawGraph( 0, 0, gMenu3,TRUE);
		for(i=0; i<4; i++){
			iSetX = 32*(10+i);
			iSetL = 32*iPush[i];
			iSetT = 32*i;
			DrawRectGraph(iSetX , 32*16, iSetL, iSetT, 32, 32, gButton32x32, TRUE, FALSE );
			iSetX = 64*(7+i);
			iSetL = 64*iPush[i+4];
			iSetT = 32*i;
			DrawRectGraph(iSetX , 32*16, iSetL, iSetT, 64, 32, gButton64x32, TRUE, FALSE );
		}
		fUnitSystem();
	}
}

void tto::cSystem::fMenu1()
{
	iSetX	= 32+32+8;
	iSetY	= 32+32+8;
	iSetH	= 128+8;
	iSetV	= 64;
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iSystemFlag = 2;
	}
}

void tto::cSystem::fMenu2()
{
	iSetX	= 32;
	iSetY	= 32+48;
	iSetH	= 32*8;
	iSetV	= 32;
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iSystemFlag = 3;
	}
}

void tto::cSystem::fMenu3()
{
	iSetY = 32*16 ,iSetH = 32 , iSetV = 32;
	iSetX = 32*(10);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[0] = 1;
		if(iScrollVertical > 0) iScrollVertical--;
	}
	iSetX = 32*(11);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[1] = 1;
		if(iScrollVertical < 300-12) iScrollVertical++;
	}
	iSetX = 32*(12);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[2] = 1;
		iScrollVertical -= 10; if(iScrollVertical < 0) iScrollVertical = 0;
	}
	iSetX = 32*(13);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[3] = 1;
		iScrollVertical += 10; if(iScrollVertical > 300-12) iScrollVertical = 300-12;
	}

	iSetY = 32*16 ,iSetH = 64 , iSetV = 32;
	iSetX = 64*(7);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[4] = 1;
	}
	iSetX = 64*(8);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[5] = 1;
	}
	iSetX = 64*(9);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[6] = 1;
	}
	iSetX = 64*(10);
	if (fRange(iMouseX, iSetX, iSetH, iMouseY, iSetY, iSetV) == 1) {
		iPush[7] = 1;
	}
}